

"""
Django settings for project.

Generated by 'django-admin startproject' using Django 4.1.6.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""
import os
from pathlib import Path
import mongoengine

# mongoengine.connect(db="crazymix", host='mongodb://localhost:27017', username='crazymix-21251', password='cmarRrQaUit7lDbqExOC7jERTJNPvc')
# mongoengine.connect('mongodb+srv://crazymix-21251:<cmarRrQaUit7lDbqExOC7jERTJNPvc>@cluster0.kphobls.mongodb.net/test')
# mongoengine.connect(db=db_name, host=hostname, username=username, password=pwd)
# mongoengine.connect("mongodb://ac-ljhgpgu-shard-00-00.4b2fkv5.mongodb.net:27017,ac-ljhgpgu-shard-00-01.4b2fkv5.mongodb.net:27017,ac-ljhgpgu-shard-00-02.4b2fkv5.mongodb.net:27017/projet_web?replicaSet=atlas-12uz6e-shard-0")
# mongoengine.connect("mongo "mongodb://ac-ljhgpgu-shard-00-00.4b2fkv5.mongodb.net:27017,ac-ljhgpgu-shard-00-01.4b2fkv5.mongodb.net:27017,ac-ljhgpgu-shard-00-02.4b2fkv5.mongodb.net:27017/projet_web?replicaSet=atlas-12uz6e-shard-0" --ssl --authenticationDatabase admin --username marieville --password 123456")
#
mongoengine.connect(db="projet_web", host='mongodb+srv://ouiza:Ouiza@cluster0.kphobls.mongodb.net/?retryWrites=true&w=majority')

# compass:
# mongoengine.connect(hots="mongodb+srv://crazymix-21251:123456@cluster0.kphobls.mongodb.net/test")

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-4u5gw2kjv%#u)g8#rkj^skdl%$zrj+_gk!fc@nb!gog2b8oo-d'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = False

ALLOWED_HOSTS = ['127.0.0.1', 'localhost', '.vercel.app', 'projet-approfondissement-web-9km3.vercel.app', '.now.sh']


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'crazymix',
    'django_mongoengine',
    'django_mongoengine.mongo_admin',
    'django_mongoengine.mongo_auth',
]

AUTHENTICATION_BACKENDS = (
    'django.contrib.auth.backends.ModelBackend',
)

SESSION_ENGINE = 'django_mongoengine.sessions'
SESSION_SERIALIZER = 'django_mongoengine.sessions.BSONSerializer'

AUTH_USER_MODEL = 'crazymix.MyUser'

#MONGOENGINE_USER_DOCUMENT = 'django_mongoengine.mongo_auth.models.User'

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'whitenoise.middleware.WhiteNoiseMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware'
]

MONGODB_DATABASES = {
    "default": {
        'ENGINE' : 'django_mongoengine',
        "name": 'projet_web',
        "host": 'mongodb+srv://ouiza:Ouiza@cluster0.kphobls.mongodb.net/?retryWrites=true&w=majority',
        "username" : 'ouiza',
        "password": 'Ouiza',
        "authMecanism":'SCRAM-SHA-1',
        "tz_aware": True, # if you using timezones in django (USE_TZ = True)
    },
}

ROOT_URLCONF = 'projet_web_app.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [str(BASE_DIR.joinpath('templates'))],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'projet_web_app.wsgi.application'


AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = 'fr-ca'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/
# STATICFILES_DIRS = os.path.join(BASE_DIR, 'static'),
# STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles_build', 'static')

STATIC_URL = 'static/'
# STATICFILES_DIRS = [str(BASE_DIR.joinpath('crazymix/static'))]
MEDIA_URL='/media/'
MEDIA_ROOT=BASE_DIR / "media"


# Static files tests
# STATICFILES_DIRS = os.path.join(BASE_DIR, 'crazymix/static'),
# STATICFILES_DIRS = [
#     BASE_DIR / 'static'
# ]
# STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles', 'staticx')

STATICFILES_DIRS = [str(BASE_DIR.joinpath('crazymix/static'))]
STATIC_ROOT = os.path.join(BASE_DIR, 'staticfiles', 'static')

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
LOGIN_REDIRECT_URL= '/crazymix'